VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "FilenameClass"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Clase global con funciones de utilidad para gestin de ficheros"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Public Function URL2filename(url As String) As String
  Dim f As String
  url = prefixDrop(url, "http://")
  url = prefixDrop(url, "ftp://")
  url = StringToDirName(url)
  URL2filename = url
End Function


Public Function StringToFilename(ByVal nameStr As String) As String
Attribute StringToFilename.VB_Description = "Dada una cadena con caracteres no validos para nombres de fichero, elimina estos, de forma que como salida obtengamos un nombre de fichero vlido."
    'converts a string to a valid filename
    'for example:
    ' "b/e\av=: is" becomes "beavis"
    
    'RemoveChar nameStr, " "
    'RemoveChar nameStr, "."
    RemoveChar nameStr, ":"
    RemoveChar nameStr, "'"
    RemoveChar nameStr, Chr(34)
    RemoveChar nameStr, "/"
    RemoveChar nameStr, "\"
    RemoveChar nameStr, "="
    RemoveChar nameStr, "<"
    RemoveChar nameStr, ">"
    RemoveChar nameStr, "*"
    RemoveChar nameStr, ","
    RemoveChar nameStr, "?"
    StringToFilename = nameStr ' Left(sSrc, 8)
End Function

Public Function StringToDirName(ByVal nameStr As String) As String
    'converts a string to a valid filename
    'for example:
    ' "b/e\av=: is" becomes "beavis"
    
    'RemoveChar nameStr, " "
    'RemoveChar nameStr, "."
    RemoveChar nameStr, ":"
    RemoveChar nameStr, "'"
    RemoveChar nameStr, Chr(34)
    'RemoveChar nameStr, "/"
    'RemoveChar nameStr, "\"
    RemoveChar nameStr, "="
    RemoveChar nameStr, "<"
    RemoveChar nameStr, ">"
    RemoveChar nameStr, "*"
    RemoveChar nameStr, ","
    RemoveChar nameStr, "?"
    ReplaceChar nameStr, "/", "\"
    StringToDirName = nameStr ' Left(sSrc, 8)
End Function


Public Sub splitFilename(ByVal dirAndFileNames As String, dir As String, filename As String)
Attribute splitFilename.VB_Description = "Dado un nombre de fichero con un directorio, separa el nombre del fichero y el del directorio."
  Dim pos As Integer
  
  dir = ""
  filename = ""
  Do
    pos = InStr(1, dirAndFileNames, "\")
    dir = dir & Left(dirAndFileNames, pos)
    dirAndFileNames = Mid(dirAndFileNames, pos + 1)
  Loop While pos <> 0
  filename = dirAndFileNames
End Sub


Public Sub createDirectory(d As String)
Attribute createDirectory.VB_Description = "Crea un directorio, si no existe ya, a partir de una cadena con la especificacin del directorio que queremos crear."
  Dim pos As Integer
  On Error Resume Next
  If Right(d, 1) <> "\" Then
    d = d & "\"
  End If
  pos = InStr(4, d, "\")
  While pos > 0
    If dir(Left(d, pos - 1) & "\.", vbDirectory) = "" Then
      ' La condicin del if comprueba si existe el directorio. Para ello, mira si existe el directorio actual, ".".
      ' Nota: No funciona con CDR, no existe el directorio "."
      MkDir Left(d, pos - 1)
    End If
    pos = InStr(pos + 1, d, "\")
  Wend
End Sub

Private Function RemoveChar(sSrc As String, sChar As String) As String
    ' "fat old sun" becomes "fatoldsun" if sChar = " "
    
    Dim iPos As Integer
    
    iPos = 1
    Do
        iPos = InStr(iPos, sSrc, sChar)
        If iPos > 0 Then
            sSrc = Left(sSrc, iPos - 1) & " " & Right(sSrc, Len(sSrc) - iPos)
        End If
    Loop While iPos <> 0
    
   
End Function

Private Function ReplaceChar(sSrc As String, sCharOld As String, sCharNew As String) As String
    
    Dim iPos As Integer
    
    iPos = 1
    Do
        iPos = InStr(iPos, sSrc, sCharOld)
        If iPos > 0 Then
            sSrc = Left(sSrc, iPos - 1) & sCharNew & Right(sSrc, Len(sSrc) - iPos)
        End If
    Loop While iPos <> 0
    
   
End Function


Private Function prefixDrop(ByVal str As String, ByVal prefix As String) As String
  If Left(str, Len(prefix)) = prefix Then
    str = Mid(str, Len(prefix) + 1)
  End If
  prefixDrop = str
End Function

